﻿using EnvDTE;
using EnvDTE80;
using Microsoft.VisualStudio.TemplateWizard;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace MyProjectWizard
{
    public class WizardImplementation : IWizard
    {
        private UserInputForm inputForm;
        private string customMessage;
        private Bootstrapper bootstrapper;
        private DTE2 _dte; 
        // This method is called before opening any item that
        // has the OpenInEditor attribute.
        public WizardImplementation()
        {
            bootstrapper = new Bootstrapper();
        }
        public void BeforeOpeningFile(ProjectItem projectItem)
        {
          
        }

        public void ProjectFinishedGenerating(Project project)
        {
        }

        // This method is only called for item templates,
        // not for project templates.
        public void ProjectItemFinishedGenerating(ProjectItem
            projectItem)
        {
        }

        // This method is called after the project is created.
        public async void RunFinished()
        {
            bootstrapper.Run();
            _dte.Solution.Close();
            try
            {
               Task.Delay(1000);
                _dte.Solution.Open("C:\\Users\\chris\\Desktop\\ConsoleApp\\ConsoleApp.sln");
            }
            catch
            {

            }
        }

        public void RunStarted(object automationObject,
            Dictionary<string, string> replacementsDictionary,
            WizardRunKind runKind, object[] customParams)
        {
            _dte = (DTE2)automationObject;
        }

        // This method is only called for item templates,
        // not for project templates.
        public bool ShouldAddProjectItem(string filePath)
        {
            return true;
        }
    }
}
