﻿using MyProjectWizard.ViewModels;
using MyProjectWizard.Views;
using Prism.Ioc;
using Prism.Unity;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace MyProjectWizard
{
    class Bootstrapper : PrismBootstrapper
    {
        protected override DependencyObject CreateShell()
        {
         
            var mainWindow = Container.Resolve<MainWindow>();

            return mainWindow;
        }
        protected override void OnInitialized()
        {

            if (Shell is Window window)
            {
                MainWindowViewModel vm = (MainWindowViewModel)window.DataContext;
                vm.OnRequestClose += (s, e) => window.Close();
                window.ShowDialog();
            }
       
        }

        protected override void RegisterTypes(IContainerRegistry containerRegistry)
        {

        }
    }
}
