﻿using Microsoft.VisualStudio.PlatformUI;
using Microsoft.VisualStudio.Shell.Interop;
using Prism.Mvvm;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MyProjectWizard.ViewModels
{
    public class MainWindowViewModel:BindableBase
    {
        public event EventHandler OnRequestClose;
        public DelegateCommand SubmitCommand { get; private set; }
        public MainWindowViewModel()
        {
          
          
            SubmitCommand = new DelegateCommand(Submit);
        }
        void Submit()
        {
            OnRequestClose(this, new EventArgs());
        }
    }
}
